﻿using Microsoft.ML;
using Microsoft.ML.Data;
using System.Formats.Tar;
//Natan Wadowski
namespace ML_NET
{
    internal class Program
    {
        class MusicData
        {
            [LoadColumn(0)]
            public float wiek;
            [LoadColumn(1)]
            public float plec;
            [LoadColumn(2)]
            public string gatunek;
        }
        class MusicPrediction : MusicData
        {
            [ColumnName("PredictedLabel")]
            public string przewidywanie;
        }

        static void Main(string[] args)
        {
            var context = new MLContext();
            var path = @"C:\Users\pk\source\repos\ML NET\ML NET\dane.csv";
            
            var dane = context.Data.LoadFromTextFile<MusicData>(path, separatorChar:',', hasHeader:true);

            var pipeline = context.Transforms.Conversion.MapValueToKey("Label", "gatunek")
                .Append(context.Transforms.Concatenate("Features", "wiek", "plec"))
                .Append(context.MulticlassClassification.Trainers.NaiveBayes())
                .Append(context.Transforms.Conversion.MapKeyToValue("PredictedLabel"));

            var model = pipeline.Fit(dane);

            var engine = context.Model.CreatePredictionEngine<MusicData, MusicPrediction>(model);

            var test = new MusicData();
            test.wiek = 22;
            test.plec = 1;

            var przewidywanie = engine.Predict(test);

            Console.WriteLine(przewidywanie.przewidywanie);
        }
    }
}